"""
    API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: v2.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from testit_api_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from testit_api_client.exceptions import ApiAttributeError


def lazy_import():
    from testit_api_client.model.attachment_put_model import AttachmentPutModel
    from testit_api_client.model.auto_test_id_model import AutoTestIdModel
    from testit_api_client.model.iteration_put_model import IterationPutModel
    from testit_api_client.model.link_post_model import LinkPostModel
    from testit_api_client.model.step_post_model import StepPostModel
    from testit_api_client.model.tag_post_model import TagPostModel
    from testit_api_client.model.work_item_entity_types import WorkItemEntityTypes
    from testit_api_client.model.work_item_priority_model import WorkItemPriorityModel
    from testit_api_client.model.work_item_states import WorkItemStates
    globals()['AttachmentPutModel'] = AttachmentPutModel
    globals()['AutoTestIdModel'] = AutoTestIdModel
    globals()['IterationPutModel'] = IterationPutModel
    globals()['LinkPostModel'] = LinkPostModel
    globals()['StepPostModel'] = StepPostModel
    globals()['TagPostModel'] = TagPostModel
    globals()['WorkItemEntityTypes'] = WorkItemEntityTypes
    globals()['WorkItemPriorityModel'] = WorkItemPriorityModel
    globals()['WorkItemStates'] = WorkItemStates


class WorkItemPostModel(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('duration',): {
            'inclusive_maximum': 86400000,
            'inclusive_minimum': 0,
        },
        ('name',): {
            'min_length': 1,
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'entity_type_name': (WorkItemEntityTypes,),  # noqa: E501
            'state': (WorkItemStates,),  # noqa: E501
            'priority': (WorkItemPriorityModel,),  # noqa: E501
            'steps': ([StepPostModel],),  # noqa: E501
            'precondition_steps': ([StepPostModel],),  # noqa: E501
            'postcondition_steps': ([StepPostModel],),  # noqa: E501
            'duration': (int,),  # noqa: E501
            'attributes': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'tags': ([TagPostModel],),  # noqa: E501
            'links': ([LinkPostModel],),  # noqa: E501
            'name': (str,),  # noqa: E501
            'project_id': (str,),  # noqa: E501
            'section_id': (str,),  # noqa: E501
            'description': (str, none_type,),  # noqa: E501
            'attachments': ([AttachmentPutModel], none_type,),  # noqa: E501
            'iterations': ([IterationPutModel], none_type,),  # noqa: E501
            'auto_tests': ([AutoTestIdModel], none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'entity_type_name': 'entityTypeName',  # noqa: E501
        'state': 'state',  # noqa: E501
        'priority': 'priority',  # noqa: E501
        'steps': 'steps',  # noqa: E501
        'precondition_steps': 'preconditionSteps',  # noqa: E501
        'postcondition_steps': 'postconditionSteps',  # noqa: E501
        'duration': 'duration',  # noqa: E501
        'attributes': 'attributes',  # noqa: E501
        'tags': 'tags',  # noqa: E501
        'links': 'links',  # noqa: E501
        'name': 'name',  # noqa: E501
        'project_id': 'projectId',  # noqa: E501
        'section_id': 'sectionId',  # noqa: E501
        'description': 'description',  # noqa: E501
        'attachments': 'attachments',  # noqa: E501
        'iterations': 'iterations',  # noqa: E501
        'auto_tests': 'autoTests',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, entity_type_name, state, priority, steps, precondition_steps, postcondition_steps, duration, attributes, tags, links, name, project_id, section_id, *args, **kwargs):  # noqa: E501
        """WorkItemPostModel - a model defined in OpenAPI

        Args:
            entity_type_name (WorkItemEntityTypes):
            state (WorkItemStates):
            priority (WorkItemPriorityModel):
            steps ([StepPostModel]):
            precondition_steps ([StepPostModel]):
            postcondition_steps ([StepPostModel]):
            duration (int): Must be 0 for shared steps and greater than 0 for the other types of work items
            attributes ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            tags ([TagPostModel]):
            links ([LinkPostModel]):
            name (str):
            project_id (str): This property is used to link workitem with project
            section_id (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str, none_type): [optional]  # noqa: E501
            attachments ([AttachmentPutModel], none_type): [optional]  # noqa: E501
            iterations ([IterationPutModel], none_type): [optional]  # noqa: E501
            auto_tests ([AutoTestIdModel], none_type): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.entity_type_name = entity_type_name
        self.state = state
        self.priority = priority
        self.steps = steps
        self.precondition_steps = precondition_steps
        self.postcondition_steps = postcondition_steps
        self.duration = duration
        self.attributes = attributes
        self.tags = tags
        self.links = links
        self.name = name
        self.project_id = project_id
        self.section_id = section_id
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, entity_type_name, state, priority, steps, precondition_steps, postcondition_steps, duration, attributes, tags, links, name, project_id, section_id, *args, **kwargs):  # noqa: E501
        """WorkItemPostModel - a model defined in OpenAPI

        Args:
            entity_type_name (WorkItemEntityTypes):
            state (WorkItemStates):
            priority (WorkItemPriorityModel):
            steps ([StepPostModel]):
            precondition_steps ([StepPostModel]):
            postcondition_steps ([StepPostModel]):
            duration (int): Must be 0 for shared steps and greater than 0 for the other types of work items
            attributes ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            tags ([TagPostModel]):
            links ([LinkPostModel]):
            name (str):
            project_id (str): This property is used to link workitem with project
            section_id (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str, none_type): [optional]  # noqa: E501
            attachments ([AttachmentPutModel], none_type): [optional]  # noqa: E501
            iterations ([IterationPutModel], none_type): [optional]  # noqa: E501
            auto_tests ([AutoTestIdModel], none_type): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.entity_type_name = entity_type_name
        self.state = state
        self.priority = priority
        self.steps = steps
        self.precondition_steps = precondition_steps
        self.postcondition_steps = postcondition_steps
        self.duration = duration
        self.attributes = attributes
        self.tags = tags
        self.links = links
        self.name = name
        self.project_id = project_id
        self.section_id = section_id
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
